package com.xkrs.util;

import com.xkrs.dao.SpecDao;
import com.xkrs.model.entity.SpecEntity;
import org.apache.http.util.TextUtils;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.persistence.criteria.Predicate;
import java.util.ArrayList;
import java.util.List;

/**
 * @Author: XinYi Song
 * @Date: 2022/1/19 13:56
 */
@Component
public class SpecQuery {

    @Resource
    private SpecDao specDao;

    /**
     * 动态多条件查询规格信息
     *
     * @return
     */
    public List<SpecEntity> selectSpec(String partNo, String inspectionItemCode) {
        Specification<SpecEntity> specification = (root, criteriaQuery, criteriaBuilder) -> {
            List<Predicate> list = new ArrayList<>();
            if (!TextUtils.isEmpty(partNo)) {
                list.add(criteriaBuilder.equal(root.get("partNo").as(String.class), partNo));
            }
            if (!TextUtils.isEmpty(inspectionItemCode)) {
                list.add(criteriaBuilder.equal(root.get("inspectionItemCode").as(String.class), inspectionItemCode));
            }
            Predicate[] predicates = new Predicate[list.size()];
            return criteriaBuilder.and(list.toArray(predicates));
        };
        return specDao.findAll(specification);
    }
}
